#include <jni.h>
#include "SQL2C.h"
#include <mysql/mysql.h>

#define MYSQL2jlong(x) ((jlong)(unsigned int)x)
#define jlong2MYSQL(x) ((MYSQL *)(unsigned int)x)

#define MYSQL_RES2jlong(x) ((jlong)(unsigned int)x)
#define jlong2MYSQL_RES(x) ((MYSQL_RES *)(unsigned int)x)

JNIEXPORT jlong JNICALL Java_SQL2C_sql_1connect
  (JNIEnv *env, jobject obj)
{
MYSQL *conn;
	
	conn=mysql_real_connect(mysql_init(NULL),NULL,"root","","mysql",0,NULL,0);
	return(MYSQL2jlong(conn));
}


JNIEXPORT jlong JNICALL Java_SQL2C_sql_1query
  (JNIEnv *env, jobject obj, jlong jconn, jstring jsqlstr)
{
char *sqlstr;
MYSQL_RES *res;
	
	if((jconn==0)||(jsqlstr==NULL)) return(0);
	sqlstr=(char *) (*env)->GetStringUTFChars(env, jsqlstr, NULL);

	if(mysql_query(jlong2MYSQL(jconn),sqlstr))
	{
		(*env)->ReleaseStringUTFChars(env, jsqlstr, sqlstr);
		return(0);
	}
	(*env)->ReleaseStringUTFChars(env, jsqlstr, sqlstr);

	res=mysql_store_result(jlong2MYSQL(jconn));
	return(MYSQL_RES2jlong(res));
}
  
JNIEXPORT void JNICALL Java_SQL2C_sql_1free
  (JNIEnv *env, jobject obj, jlong jrs)
{
	if(jrs==0) return;
	mysql_free_result(jlong2MYSQL_RES(jrs));
}
  
